<template>
  <div id="catalog">
    <app-text-popup :message="popupMessage"></app-text-popup>
    <h1 v-if="headerText">{{headerText}}</h1>
    <div :id="'categ-'+categ.id" v-for="(categ, index) in getItems" :key="categ.id">
      <h2 v-if="index > 0">{{categ.text | uppercase}}</h2>
      <div class="product-container">
        <app-product :key="item.id" v-for="item in categ.items" :item="item"/>
      </div>
    </div>
    <div>
      <h2 v-if="footerText">{{footerText}}</h2>
      <div class="footer-content" v-html="getPage.content"></div>
    </div>
    <transition name="delivery">
      <div id="delivery-form-back" v-show="showDelivery" @click="hideDeliveryEvent">
        <div id="delivery-form">
          <app-delivery-form/>
        </div>
      </div>
    </transition>
  </div>
</template>
<script>
import Product from "./Product";
import DeliveryForm from "./DeliveryForm";
import TextPopup from "./TextPopup";
import { mapGetters, mapMutations } from "vuex";
export default {
  components: {
    "app-product": Product,
    "app-delivery-form": DeliveryForm,
    "app-text-popup": TextPopup
  },
  data() {
    return {
      popupMessage:
        "ДОРОГИЕ ДРУЗЬЯ! МЫ РАБОТАЕМ С 11:00 до 23:00! ВЫ МОЖЕТЕ СДЕЛАТЬ СЕЙЧАС ПРЕДЗАКАЗ! МЫ ДОСТАВИМ ЕГО К 11:30 УТРА!"
    };
  },
  methods: {
    ...mapMutations(["hideDelivery"]),
    hideDeliveryEvent(event) {
      if (event.target.id == "delivery-form-back") this.hideDelivery();
    }
  },
  computed: {
    ...mapGetters(["getItems", "showDelivery", "getPage"]),
    headerText() {
      return this.getPage.firstHeader;
    },
    footerText() {
      return this.getPage.contentHeader;
    }
  },
  created() {
    // console.log(this.$route.path);
    // switch (this.$route.path) {
    //   case "/pizza-nagatinskaya/":
    //     this.$store.commit("setFirstRoute", this.$route.path);
    //     break;
    //   case "/pizza-anokhina/":
    //     this.$store.commit("setFirstRoute", this.$route.path);
    //     break;
    // }
  }
};
</script>
<style scoped>
#catalog {
  display: flex;
  flex-flow: column;
  align-items: center;
  justify-content: space-around;
  width: 100%;
}
h1 {
  padding: 20px;
  padding-top: 50px;
  text-align: center;
  font-size: 2em;
}
h2 {
  padding: 20px;
  padding-top: 50px;
  text-align: center;
  font-size: 2em;
}
.product-container {
  display: flex;
  flex-flow: row wrap;
  justify-content: center;
}
#delivery-form-back {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background-color: #00000055;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 10;
}
#delivery-form {
  display: block;
  flex: 1;
  max-width: 800px;
  padding: 20px;
  background-color: white;
  border: 1px solid #ddd;
}
.delivery-enter-active,
.delivery-leave-active {
  transition: opacity 0.1s;
}
.delivery-enter,
.delivery-leave-to {
  opacity: 0;
}
.footer-content {
  text-align: left;
  line-height: 1.5em;
  padding: 20px;
  padding-bottom: 50px;
}
</style>
